/*
 * File: banner_page.c
 *
 * Description:
 *
 * Author: Massimo Carboni - INFN/LNF Frascati 
 * e-mail: massimo.carboni@lnf.infn.it
 *
 * History revision:
 *  9-Sep-1998 (FP) Inserted and adapted for printmi server.
 *  8-Feb-1999 (MC-FP) Added Job ID into banner format.
 *
 */

#include <stdio.h>
#include <string.h>
#include <time.h>

#include "spooler_queue.h"

#define COVER_PAGE "\n\
%%!PS-Adobe\n\
%%%%Creator: Massimo Carboni, carboni@hpserver.lnf.infn.it\n\
%%%%CreationDate: 24-Nov-1993\n\
%%%%Title: Cover print page\n\
%%%%BoundingBox: \n\
%%%%EndComments\n\
\n\
%%-----------Variables-----------\n\
\n\
/MainFont\n\
  /Helvetica-Bold findfont 30 scalefont def\n\
/SloganFont\n\
  /Helvetica-Oblique findfont 27 scalefont def\n\
/OwnerFont\n\
  /Helvetica findfont 18 scalefont def\n\
\n\
%%-----------Procedure-----------\n\
/inch\n\
{ 72 mul} def\n\
\n\
/line\n\
{ 12 mul} def\n\
\n\
/advanceLine\n\
{/NextLine\n\
 NextLine LineSpace sub \n\
 def} def\n\
\n\
/advancePara\n\
{/NextLine\n\
 NextLine ParaSpace sub \n\
 def} def\n\
\n\
/rightshow \n\
{dup stringwidth pop\n\
 120 exch sub\n\
 0 rmoveto\n\
 show} def\n\
\n\
/centerText\n\
{dup\n\
 stringwidth pop\n\
 2 div\n\
 RightMargin LeftMargin sub 2 div\n\
 exch sub\n\
 LeftMargin add \n\
 NextLine moveto\n\
 show} def\n\
\n\
/rightJustifyText\n\
{dup\n\
 stringwidth pop\n\
 RightColumn exch sub \n\
 NextLine moveto\n\
 show} def\n\
\n\
/bottomRightText\n\
{dup\n\
 stringwidth pop\n\
 InfoMargin exch sub \n\
 NextLine moveto\n\
 show} def\n\
\n\
/bodyText\n\
{SecondColumn NextLine moveto\n\
 show} def\n\
\n\
/CardOutline\n\
{newpath\n\
 20 30 moveto\n\
 0 750 rlineto\n\
 550 0 rlineto\n\
 0 -750 rlineto\n\
 closepath\n\
 .5 setlinewidth\n\
 stroke} def\n\
\n\
/doBorder\n\
{29 39 moveto\n\
 0 732 rlineto\n\
 532 0 rlineto\n\
 0 -732 rlineto\n\
 closepath\n\
 2 setlinewidth\n\
 stroke} def\n\
\n\
/TopStart 9.5 inch def\n\
/BodyStart 3.5 inch def\n\
\n\
/LineSpace 14 def\n\
/ParaSpace 28 def\n\
\n\
/LeftMargin   0.5 inch def\n\
/RightMargin  8.0 inch def\n\
/BottomMargin 0.7 inch def\n\
/InfoMargin   7.5 inch def\n\
/RightColumn  2.0 inch def\n\
/SecondColumn 2.1 inch def\n\
\n\
%%-----------Main Program-----------\n\
CardOutline\n\
doBorder\n\
\n\
/Helvetica-Bold findfont 26 scalefont setfont\n\
\n\
0 setgray \n\
/NextLine TopStart def\n\
(%s@%s) centerText\n\
\n\
0.5 setgray \n\
/NextLine NextLine 40 sub def\n\
(%s) centerText\n\
\n\
/Helvetica-BoldOblique findfont 26 scalefont setfont\n\
0 setgray \n\
/NextLine NextLine 40 sub def\n\
(%s) centerText\n\
\n\
/Helvetica findfont 13 scalefont setfont\n\
/NextLine BodyStart def\n\
(%s) bodyText advanceLine\n\
(%s) bodyText advanceLine\n\
(%s) bodyText advanceLine\n\
(%s) bodyText advanceLine\n\
(  ) bodyText advanceLine\n\
(  ) bodyText advanceLine\n\
\n\
/Helvetica findfont 13 scalefont setfont\n\
/NextLine BodyStart def\n\
(User:) rightJustifyText advanceLine\n\
(Submitted:) rightJustifyText advanceLine\n\
(Printer:)  rightJustifyText advanceLine\n\
(File:)  rightJustifyText advanceLine\n\
\n\
/Times-Italic findfont 15 scalefont setfont\n\
/NextLine BottomMargin def\n\
(Print server version %s) bottomRightText advanceLine\n\
\n\
0.3 0.3 scale\n\
2 inch 2 inch translate\n\
\n\
"
#define INFN_LOGO "\
%%!\n\
%%%%BoundingBox: 8 22 298 204\n\
%%%%Title: logo\n\
%%%%CreationDate: Fri Nov 26 12:38:07 1993\n\
%%%%Creator: Tgif-2.13 by William Chia-Wei Cheng (william@cs.UCLA.edu)\n\
%%%%DocumentFonts: Times-Roman Helvetica Courier NewCenturySchlbk Symbol\n\
%%%%EndComments\n\
%%%%BeginProlog\n\
%%\n\
%%	Due to bugs in Transcript, the 'PS-Adobe-' stuff is omitted from line 1\n\
%%\n\
\n\
/tgifdict 132 dict def\n\
tgifdict begin\n\
\n\
%%\n\
%%	Using a zero value radius for an ellipse or an arc would result\n\
%%		in a non-invertible CTM matrix which causes problem when this\n\
%%		when this PostScript is wrapped inside other routines, such as\n\
%%		the multi.ps package from\n\
%%		ftp.ucc.su.oz.au:/pub/ps_printing/multi.  You can overcome such\n\
%%		error by uncommenting the sole line of the procedure below:\n\
%%\n\
/tgif_min_radius\n\
 {\n\
%%    dup 0.01 lt { pop 0.01 } if\n\
 } bind def\n\
\n\
/tgifellipsedict 6 dict def\n\
tgifellipsedict /mtrx matrix put\n\
\n\
/tgifellipse\n\
 { tgifellipsedict begin\n\
      /yrad exch def\n\
      /xrad exch def\n\
      /y exch def\n\
      /x exch def\n\
      /savematrix mtrx currentmatrix def\n\
      x y translate\n\
      xrad yrad scale\n\
      0 0 1 0 360 arc\n\
      savematrix setmatrix\n\
   end\n\
 } def\n\
\n\
/tgifarrowtipdict 8 dict def\n\
tgifarrowtipdict /mtrx matrix put\n\
\n\
/tgifarrowtip\n\
 { tgifarrowtipdict begin\n\
      /dy exch def\n\
      /dx exch def\n\
      /h exch def\n\
      /w exch def\n\
      /y exch def\n\
      /x exch def\n\
      /savematrix mtrx currentmatrix def\n\
      x y translate\n\
      dy dx atan rotate\n\
      0 0 moveto\n\
      w neg h lineto\n\
      w neg h neg lineto\n\
      savematrix setmatrix\n\
   end\n\
 } def\n\
\n\
/tgifarcdict 8 dict def\n\
tgifarcdict /mtrx matrix put\n\
\n\
/tgifarcn\n\
 { tgifarcdict begin\n\
      /endangle exch def\n\
      /startangle exch def\n\
      /yrad exch def\n\
      /xrad exch def\n\
      /y exch def\n\
      /x exch def\n\
      /savematrix mtrx currentmatrix def\n\
      x y translate\n\
      xrad yrad scale\n\
      0 0 1 startangle endangle arc\n\
      savematrix setmatrix\n\
   end\n\
 } def\n\
\n\
/tgifarc\n\
 { tgifarcdict begin\n\
      /endangle exch def\n\
      /startangle exch def\n\
      /yrad exch def\n\
      /xrad exch def\n\
      /y exch def\n\
      /x exch def\n\
      /savematrix mtrx currentmatrix def\n\
      x y translate\n\
      xrad yrad scale\n\
      0 0 1 startangle endangle arcn\n\
      savematrix setmatrix\n\
   end\n\
 } def\n\
\n\
/tgifsetuserscreendict 22 dict def\n\
tgifsetuserscreendict begin\n\
   /tempctm matrix def\n\
   /temprot matrix def\n\
   /tempscale matrix def\n\
\n\
   /concatprocs\n\
    { /proc2 exch cvlit def\n\
      /proc1 exch cvlit def\n\
      /newproc proc1 length proc2 length add array def\n\
      newproc 0 proc1 putinterval\n\
      newproc proc1 length proc2 putinterval\n\
      newproc cvx\n\
    } def\n\
   /resmatrix matrix def\n\
   /findresolution\n\
    { 72 0 resmatrix defaultmatrix dtransform\n\
      /yres exch def /xres exch def\n\
      xres dup mul yres dup mul add sqrt\n\
    } def\n\
end\n\
\n\
/tgifsetuserscreen\n\
 { tgifsetuserscreendict begin\n\
      /spotfunction exch def\n\
      /screenangle exch def\n\
      /cellsize exch def\n\
\n\
      /m tempctm currentmatrix def\n\
      /rm screenangle temprot rotate def\n\
      /sm cellsize dup tempscale scale def\n\
\n\
      sm rm m m concatmatrix m concatmatrix pop\n\
\n\
      1 0 m dtransform /y1 exch def /x1 exch def\n\
\n\
      /veclength x1 dup mul y1 dup mul add sqrt def\n\
      /frequency findresolution veclength div def\n\
\n\
      /newscreenangle y1 x1 atan def\n\
\n\
      m 2 get m 1 get mul m 0 get m 3 get mul sub 0 gt\n\
\n\
      {{neg} /spotfunction load concatprocs\n\
         /spotfunction exch def\n\
      } if\n\
\n\
      frequency newscreenangle /spotfunction load setscreen\n\
   end\n\
 } def\n\
\n\
/tgifsetpatterndict 18 dict def\n\
tgifsetpatterndict begin\n\
   /bitison\n\
    { /ybit exch def /xbit exch def\n\
      /bytevalue bstring ybit bwidth mul xbit 8 idiv add get def\n\
\n\
      /mask 1 7 xbit 8 mod sub bitshift def\n\
      bytevalue mask and 0 ne\n\
    } def\n\
end\n\
\n\
/tgifbitpatternspotfunction\n\
 { tgifsetpatterndict begin\n\
      /y exch def /x exch def\n\
\n\
      /xindex x 1 add 2 div bpside mul cvi def\n\
      /yindex y 1 add 2 div bpside mul cvi def\n\
\n\
      xindex yindex bitison\n\
       { /onbits onbits 1 add def 1 }\n\
       { /offbits offbits 1 add def 0 }\n\
       ifelse\n\
   end\n\
 } def\n\
\n\
/tgifsetpattern\n\
 { tgifsetpatterndict begin\n\
      /cellsz exch def\n\
      /angle exch def\n\
      /bwidth exch def\n\
      /bpside exch def\n\
      /bstring exch def\n\
\n\
      /onbits 0 def /offbits 0 def\n\
      cellsz angle /tgifbitpatternspotfunction load tgifsetuserscreen\n\
      {} settransfer\n\
      offbits offbits onbits add div setgray\n\
   end\n\
 } def\n\
\n\
/tgifxpmdict 4 dict def\n\
/tgifbwpicstr 1 string def\n\
/tgifcolorpicstr 3 string def\n\
\n\
/tgifsetpixels { tgifxpmdict begin /pixels exch def end } def\n\
\n\
/tgifsetpix { tgifxpmdict begin pixels 3 1 roll putinterval end } def\n\
\n\
/tgifbwspot\n\
 { tgifxpmdict begin\n\
      /index exch def\n\
      tgifbwpicstr 0\n\
      pixels index 3 mul 3 getinterval aload pop\n\
      255 mul .114 mul exch 255 mul .587 mul add exch 255 mul .299 mul add\n\
      cvi put\n\
      tgifbwpicstr\n\
   end\n\
 } def\n\
\n\
/tgifcolorspot\n\
 { tgifxpmdict begin\n\
      /index exch def\n\
      pixels index 3 mul 3 getinterval aload pop\n\
      255 mul cvi tgifcolorpicstr 2 3 -1 roll put\n\
      255 mul cvi tgifcolorpicstr 1 3 -1 roll put\n\
      255 mul cvi tgifcolorpicstr 0 3 -1 roll put\n\
      tgifcolorpicstr\n\
   end\n\
 } def\n\
\n\
/tgifnewcolorspot\n\
 { tgifxpmdict begin\n\
      /index exch def\n\
      pixels index 3 mul 3 getinterval aload pop setrgbcolor\n\
   end\n\
 } def\n\
\n\
/tgifcolordict 4 dict def\n\
\n\
/colorimage where\n\
 { pop }\n\
 { /colorimage\n\
   { tgifcolordict begin\n\
        pop pop pop pop pop\n\
        /ih exch def\n\
        /iw exch def\n\
        /x 0 def\n\
        /y 0 def\n\
        1 1 ih\n\
         { pop 1 1 iw\n\
            { pop currentfile\n\
              tgifbwpicstr readhexstring pop 0 get tgifnewcolorspot\n\
              x y moveto 1 0 rlineto 0 1 rlineto -1 0 rlineto\n\
              closepath fill\n\
              /x x 1 add def\n\
            } for\n\
           /y y 1 add def\n\
           /x 0 def\n\
         } for\n\
     end\n\
   } def\n\
 } ifelse\n\
\n\
/tgifpatdict 10 dict def\n\
\n\
/tgifpatbyte\n\
 { currentdict /retstr get exch\n\
   pat i cellsz mod get put\n\
 } def\n\
\n\
/tgifpatproc\n\
 { 0 1 widthlim {tgifpatbyte} for retstr\n\
   /i i 1 add def\n\
 } def\n\
\n\
/tgifpatfill\n\
 { tgifpatdict begin\n\
      /h exch def\n\
      /w exch def\n\
      /lty exch def\n\
      /ltx exch def\n\
      /cellsz exch def\n\
      /pat exch def\n\
\n\
      /widthlim w cellsz div cvi 1 sub def\n\
      /retstr widthlim 1 add string def\n\
      /i 0 def\n\
\n\
      ltx lty translate\n\
      w h true [1 0 0 1 0 0] {tgifpatproc} imagemask\n\
      ltx neg lty neg translate\n\
   end\n\
 } def\n\
\n\
/pat1 <ffffffffffffffff> def\n\
/pat2 <0000000000000000> def\n\
/pat3 <8000000008000000> def\n\
/pat4 <8800000022000000> def\n\
/pat5 <8800220088002200> def\n\
/pat6 <8822882288228822> def\n\
/pat7 <aa55aa55aa55aa55> def\n\
/pat8 <77dd77dd77dd77dd> def\n\
/pat9 <77ffddff77ffddff> def\n\
/pat10 <77ffffff77ffffff> def\n\
/pat11 <7fffffff7fffffff> def\n\
/pat12 <8040200002040800> def\n\
/pat13 <40a00000040a0000> def\n\
/pat14 <ff888888ff888888> def\n\
/pat15 <ff808080ff080808> def\n\
/pat16 <f87422478f172271> def\n\
/pat17 <038448300c020101> def\n\
/pat18 <081c22c180010204> def\n\
/pat19 <8080413e080814e3> def\n\
/pat20 <8040201008040201> def\n\
/pat21 <8844221188442211> def\n\
/pat22 <77bbddee77bbddee> def\n\
/pat23 <c1e070381c0e0783> def\n\
/pat24 <7fbfdfeff7fbfdfe> def\n\
/pat25 <3e1f8fc7e3f1f87c> def\n\
/pat26 <0102040810204080> def\n\
/pat27 <1122448811224488> def\n\
/pat28 <eeddbb77eeddbb77> def\n\
/pat29 <83070e1c3870e0c1> def\n\
/pat30 <fefdfbf7efdfbf7f> def\n\
/pat31 <7cf8f1e3c78f1f3e> def\n\
\n\
/tgifcentertext { dup stringwidth pop 2 div neg 0 rmoveto } def\n\
\n\
/tgifrighttext { dup stringwidth pop neg 0 rmoveto } def\n\
\n\
/tgifreencsmalldict 12 dict def\n\
/tgifReEncodeSmall\n\
 { tgifreencsmalldict begin\n\
      /newcodesandnames exch def\n\
      /newfontname exch def\n\
      /basefontname exch def\n\
\n\
      /basefontdict basefontname findfont def\n\
      /newfont basefontdict maxlength dict def\n\
\n\
      basefontdict\n\
      { exch dup /FID ne\n\
         { dup /Encoding eq\n\
            { exch dup length array copy newfont 3 1 roll put }\n\
            { exch newfont 3 1 roll put }\n\
            ifelse\n\
         }\n\
         { pop pop }\n\
         ifelse\n\
      }\n\
      forall\n\
\n\
      newfont /FontName newfontname put\n\
      newcodesandnames aload pop\n\
\n\
      newcodesandnames length 2 idiv\n\
      { newfont /Encoding get 3 1 roll put}\n\
      repeat\n\
\n\
      newfontname newfont definefont pop\n\
   end\n\
 } def\n\
\n\
/tgifgray { 8 1 0 72 300 32 div div tgifsetpattern } bind def\n\
\n\
/tgifboxdict 6 dict def\n\
/tgifboxstroke\n\
 { tgifboxdict begin\n\
      /pat def /w def /y2 exch def /x2 exch def /y1 exch def /x1 exch def\n\
      1.415 setmiterlimit\n\
      w 1 eq { w setlinewidth } if\n\
      pat pat1 ne pat pat2 ne and { gsave pat tgifgray } if\n\
      newpath x1 y1 moveto x2 y1 lineto x2 y2 lineto x1 y2 lineto closepath\n\
      pat pat2 eq { 1 setgray stroke 0 setgray } { stroke } ifelse\n\
      pat pat1 ne pat pat2 ne and { grestore } if\n\
      w 1 eq { 1 setlinewidth } if\n\
      1 setmiterlimit\n\
   end\n\
 } def\n\
/tgifboxfill\n\
 { tgifboxdict begin\n\
      /pat def /y2 exch def /x2 exch def /y1 exch def /x1 exch def\n\
      pat pat1 ne pat pat2 ne and { gsave pat tgifgray } if\n\
      newpath x1 y1 moveto x2 y1 lineto x2 y2 lineto x1 y2 lineto closepath\n\
      pat pat2 eq { 1 setgray fill 0 setgray } { fill } ifelse\n\
      pat pat1 ne pat pat2 ne and { grestore } if\n\
   end\n\
 } def\n\
\n\
end\n\
\n\
%%%%EndProlog\n\
%%%%Page: 1 1\n\
\n\
%%%%PageBoundingBox: 8 22 298 204\n\
tgifdict begin\n\
/tgifsavedpage save def\n\
\n\
1 setmiterlimit\n\
1 setlinewidth\n\
\n\
72 0 mul 72 11.7 mul translate\n\
72 128 div 100 mul 100 div dup neg scale\n\
\n\
gsave\n\
\n\
%% ARC\n\
gsave\n\
   pat9 8 1 0 72 300 32 div div tgifsetpattern\n\
   newpath\n\
      272 1296 moveto\n\
      272 1296 256 160 0 -180 tgifarc\n\
      272 1296 lineto\n\
   fill\n\
grestore\n\
gsave\n\
   newpath\n\
      272 1296 256 160 0 -180 tgifarc\n\
   stroke\n\
grestore\n\
\n\
%% ARC\n\
gsave\n\
   pat7 8 1 0 72 300 32 div div tgifsetpattern\n\
   newpath\n\
      272 1296 moveto\n\
      272 1296 256 160 0 180 tgifarcn\n\
      272 1296 lineto\n\
   fill\n\
grestore\n\
gsave\n\
   newpath\n\
      272 1296 256 160 0 180 tgifarcn\n\
   stroke\n\
grestore\n\
\n\
%% ARC\n\
gsave\n\
   pat9 8 1 0 72 300 32 div div tgifsetpattern\n\
   newpath\n\
      144 1296 moveto\n\
      144 1296 128 120 0 180 tgifarcn\n\
      144 1296 lineto\n\
   fill\n\
grestore\n\
gsave\n\
   newpath\n\
      144 1296 128 120 0 180 tgifarcn\n\
   stroke\n\
grestore\n\
\n\
%% ARC\n\
gsave\n\
   pat7 8 1 0 72 300 32 div div tgifsetpattern\n\
   newpath\n\
      400 1296 moveto\n\
      400 1296 128 120 180 360 tgifarcn\n\
      400 1296 lineto\n\
   fill\n\
grestore\n\
gsave\n\
   newpath\n\
      400 1296 128 120 180 360 tgifarcn\n\
   stroke\n\
grestore\n\
\n\
%% POLY/OPEN-SPLINE\n\
newpath\n\
   48 1184 moveto\n\
   96 1184 lineto\n\
   96 1376 lineto\n\
   48 1376 lineto\n\
   48 1184 lineto\n\
closepath 1 setgray eofill\n\
0 setgray\n\
gsave\n\
   newpath\n\
      48 1184 moveto\n\
      96 1184 lineto\n\
      96 1376 lineto\n\
      48 1376 lineto\n\
      48 1184 lineto\n\
   stroke\n\
grestore\n\
\n\
%% POLY/OPEN-SPLINE\n\
newpath\n\
   112 1184 moveto\n\
   112 1376 lineto\n\
   160 1376 lineto\n\
   160 1296 lineto\n\
   184 1376 lineto\n\
   232 1376 lineto\n\
   232 1184 lineto\n\
   184 1184 lineto\n\
   184 1256 lineto\n\
   160 1184 lineto\n\
   112 1184 lineto\n\
closepath 1 setgray eofill\n\
0 setgray\n\
gsave\n\
   newpath\n\
      112 1184 moveto\n\
      112 1376 lineto\n\
      160 1376 lineto\n\
      160 1296 lineto\n\
      184 1376 lineto\n\
      232 1376 lineto\n\
      232 1184 lineto\n\
      184 1184 lineto\n\
      184 1256 lineto\n\
      160 1184 lineto\n\
      112 1184 lineto\n\
   stroke\n\
grestore\n\
\n\
%% POLY/OPEN-SPLINE\n\
newpath\n\
   240 1184 moveto\n\
   240 1376 lineto\n\
   288 1376 lineto\n\
   288 1304 lineto\n\
   336 1304 lineto\n\
   336 1264 lineto\n\
   288 1264 lineto\n\
   288 1232 lineto\n\
   336 1232 lineto\n\
   336 1184 lineto\n\
   240 1184 lineto\n\
closepath 1 setgray eofill\n\
0 setgray\n\
gsave\n\
   newpath\n\
      240 1184 moveto\n\
      240 1376 lineto\n\
      288 1376 lineto\n\
      288 1304 lineto\n\
      336 1304 lineto\n\
      336 1264 lineto\n\
      288 1264 lineto\n\
      288 1232 lineto\n\
      336 1232 lineto\n\
      336 1184 lineto\n\
      240 1184 lineto\n\
   stroke\n\
grestore\n\
\n\
%% POLY/OPEN-SPLINE\n\
newpath\n\
   344 1184 moveto\n\
   344 1376 lineto\n\
   392 1376 lineto\n\
   392 1296 lineto\n\
   416 1376 lineto\n\
   464 1376 lineto\n\
   464 1184 lineto\n\
   416 1184 lineto\n\
   416 1256 lineto\n\
   392 1184 lineto\n\
   344 1184 lineto\n\
closepath 1 setgray eofill\n\
0 setgray\n\
gsave\n\
   newpath\n\
      344 1184 moveto\n\
      344 1376 lineto\n\
      392 1376 lineto\n\
      392 1296 lineto\n\
      416 1376 lineto\n\
      464 1376 lineto\n\
      464 1184 lineto\n\
      416 1184 lineto\n\
      416 1256 lineto\n\
      392 1184 lineto\n\
      344 1184 lineto\n\
   stroke\n\
grestore\n\
\n\
grestore\n\
tgifsavedpage restore\n\
end\n\
%%%%Trailer\n\
%%MatchingCreationDate: Fri Nov 26 12:38:07 1993\n\
%%%%\n\
"

int printmi_banner_page(FILE *fout,
                        char *user,
                        char *host,
                        char *queue,
                        char *file)
 {
  time_t now;
  int out = 0;
  char *trunc_file;
  char *unaliased_queue;
  char job_id[MAX_QUEUE_NAME_LEN+16];
  spooler_queue *current_queue;
  int i;

  now = time(0);

  trunc_file = strrchr(file,'/');
  if (trunc_file == NULL) 
   {
    trunc_file = strrchr(file,']');
    if (trunc_file == NULL) trunc_file = file;
    else trunc_file++;
   }
  else trunc_file++;

  job_id[0]='\000';

  /* Guess next queue ID */
  unaliased_queue = dealias_queue_name(queue);
  for (current_queue = head_spooler_queue; current_queue != NULL;
       current_queue=current_queue->next_queue)
   {
    if (strcasecmp(current_queue->name,unaliased_queue)==0)
     {
      if (current_queue->tail_job == NULL)
       {
        sprintf(job_id,"%s/%-15d",queue,1);
       }
      else
       {
        sprintf(job_id,"%s/%-15d",queue,current_queue->max_id+1);
       }
     }
   }

  for (i=strlen(job_id)-1;(job_id[i]==' ')&&(i>=0);i--) job_id[i]='\000';

  out += fprintf (fout,COVER_PAGE,
           user,
           host,
           job_id,
           trunc_file,
           user,
           ctime(&now),
           queue,
           file,
           SERVER_VERSION);

  /* The following can be replaced or commented out */
  out += fprintf (fout,INFN_LOGO);

  out += fprintf (fout,"showpage\n");

  if (out<=0) return(-1);

  return (out);
}

