proc ErrMsg {f msg} {
    catch {destroy $f}
    toplevel $f
    wm title $f "Error message"
    wm iconname $f "Error message"

    frame $f.mess -bd 1m
    pack $f.mess -side top -fill both
    label $f.mess.label -width 40 -bd 2 -text $msg
    button $f.mess.ok -text "Aknowledged" -command "destroy $f"

    pack $f.mess.label -side top -fill both -anchor center
    pack $f.mess.ok -side top -anchor center

    focus $f.mess.ok
    bind $f.mess.ok <Return> "destroy $f"
    grab set $f
    grab current $f
}

proc LoadFile  {file} {
    set filed ""
    catch {set filed [open $file]} result
    if { $filed != "" } {close $filed} {LoadDir .ned \$fileName}
    return $filed
}

proc mkFile {{w .ned} file} {
    global fileName
    global filen
    global filename datatype numbering border

    catch {destroy $w}
    toplevel $w
    wm title $w "File directory"
    wm iconname $w "Directory"

    set null ""
    set filn ""

    if { $file == "" } {
       set filen [pwd]/
    } else {
       catch {set filn [open $file]} result
       
       if { $filn != "" } {
          close $filn
          set filen $file
       } else {
          set filen [string range $file 0 [expr [string last / $file]-1]]
       }
    
       if { [file isfile $filen] } {
          set filen [string range $file 0 [expr [string last / $file]-1]]
       }
    }
    
    frame $w.mn -borderwidth 3 -relief sunken
    pack $w.mn -side top -fill both
     
    menubutton $w.mn.menu -bd 4 -relief sunken -text "$filen" -menu $w.mn.menu.m
    menu $w.mn.menu.m
    
    set md "$w.mn.menu"
    pack $md -side top -anchor center -ipadx 5 -ipady 5

    frame $w.mess -bd 1m
    pack $w.mess -side top -fill both

    frame $w.mess.e
    label $w.mess.e.label -text "Filter:" 
    entry $w.mess.e.entry -relief sunken -bd 2 -textvariable filter
    button $w.mess.e.button -text "Filter"\
                            -command "SearchFile $w.frm.list $md \$filen \$filter a"
    pack $w.mess.e.label -side left  
    pack $w.mess.e.button -side right 
    pack $w.mess.e.entry -side bottom -expand yes -fill x

    frame $w.mess.l
    label $w.mess.l.label -text "Files selection" 
    pack $w.mess.l.label -side top -anchor center
    frame $w.mess.d
    button $w.mess.d.bd -text "Directories" -command "SearchFile $w.frm.list $md \$filen * d"
    button $w.mess.d.bf -text "Files" -command "SearchFile $w.frm.list $md \$filen * f"
    button $w.mess.d.bh -text "Hidden Files" -command "SearchFile $w.frm.list $md \$filen * h"
    button $w.mess.d.ba -text "All Files" -command "SearchFile $w.frm.list $md \$filen * a"
    pack $w.mess.d.bd $w.mess.d.bf $w.mess.d.bh $w.mess.d.ba -side left -fill both

    pack $w.mess.e $w.mess.l $w.mess.d -side top -anchor center

    frame $w.frm -borderwidth 2
    pack $w.frm -side top -expand yes -fill both

    scrollbar $w.frm.scroll -relief sunken -command "$w.frm.list yview"
    listbox $w.frm.list -yscroll "$w.frm.scroll set" -relief sunken \
	    -width 30 -height 10 -setgrid 1
    pack $w.frm.list -side left -fill both -expand yes
    pack $w.frm.scroll -side right -fill y

    ListIns $w.frm.list $md $filen

    button $w.cnc -text "Cancel" -command  "destroy $w; return $null"
    pack $w.cnc -side top -fill x

    #bind $w.frm.list <Button-1> {
    #   set filename ${filen}[lindex [selection get] 0]
    #   set fileName ${filen}[lindex [selection get] 0]
    #}

    bind $w.mess.e.entry <Return> "SearchFile $w.frm.list $md \$filen \$filter a"
    bind $w.frm.list <Double-2> "
       set selec \[lindex \[selection get\] 0\]
       mkShowFile $w.frm.list.dialog \$filen\$selec
    "
    bind $w.frm.list <Double-1> "
       set selec \[lindex \[selection get\] 0\]
       if { \[string compare \$selec ../ \] == 0} {
          set filename \[file dirname \[file dirname \$filen\]\]/
          set fileName \[file dirname \[file dirname \$filen\]\]/
          ListIns $w.frm.list $md \$fileName
       } elseif { \[string compare \$selec ./ \] == 0} {
          ListIns $w.frm.list $md \$filen
       } else {
          set filename \$filen\[lindex \[selection get\] 0\]
          set fileName \$filen\[lindex \[selection get\] 0\]
          if {\[expr \[string length \$fileName \] -1\] == \[string last / \$fileName\]} {
             if {\[file readable \$fileName\] && \[file executable \$fileName\]} {
                ListIns $w.frm.list $md \$fileName
             }
          }
       }
       checkFile \$fileName
    "
    
    tkwait visibility $w.frm.list
    
 }

proc ListIns {w md file} {
    global dirname
    global filen
    set null ""

    
    if { [string length $file] == 0 } {set file /}
    set dirname $file
    set dirname [string range $dirname 0 [expr [string last / $dirname]-1]]
    if {[file isfile \$dirname]} {set dirname [string range $dirname 0 [expr [string last / $dirname]-1]]}
    set dirname $dirname/

    $md config -text "$dirname"
    set filen $dirname
    
    $md.m delete 0 1000
    if {[string length $dirname] > 1 } {
     set dirname [string range $dirname 0 [expr [string last / $dirname]-1]]
     while { [string last / $dirname] } {
	set dirname [string range $dirname 0 [expr [string last / $dirname]-1]];
	$md.m add command -label $dirname/ -command "ListIns $w $md $dirname/" }
     $md.m add command -label / -command "ListIns $w $md /"
    }

    $w delete 0 end
    set dirname $filen
    foreach i [exec ls -ap $dirname] {
       $w insert end $i
       if { [file readable $dirname/$i] == 0 } {$w delete end}
    }
}

proc insertWithTags {w text args} {
    set start [$w index insert]
    $w insert insert $text
    foreach tag [$w tag names $start] {
        $w tag remove $tag $start insert
    }
    foreach i $args {
        $w tag add $i $start insert
    }
}

proc SearchFile {w md file filter opt} {
    global dirname
    global filen

    set dirname $file
    set dirname [string range $dirname 0 [expr [string last / $dirname]-1]]
    if {[file isfile \$dirname]} {set dirname [string range $dirname 0 [expr [string last / $dirname]-1]]}
    set dirname $dirname/

    $md config -text "$dirname"
    set filen $dirname
    $md.m delete 0 1000
    if {[string length $dirname] > 1 } {
     set dirname [string range $dirname 0 [expr [string last / $dirname]-1]];
     while { [string last / $dirname] } {
	if {[string length $dirname] == 1 } {break}
	set dirname [string range $dirname 0 [expr [string last / $dirname]-1]];
	$md.m add command -label $dirname/ -command "ListIns $w $md $dirname/" }
     $md.m add command -label / -command "ListIns $w $md /"
    }

    set dirname $filen
    $w delete 0 end
    if {$filter == ""} {set filter *}

    foreach i [exec ls -ap $dirname] {
        if {[string match $filter $i]} {
	    if {[string match d $opt]} {
		if {[file isdirectory $dirname$i]} {$w insert end $i}
	    } elseif {[string match f $opt]} {
		if {[string first . $i] != 0} {
		    if {[file isfile $dirname$i]} {$w insert end $i}
		}
	    } elseif {[string match h $opt]} {
		if {[string first . $i] == 0} {$w insert end $i}
	    } elseif {[string match a $opt]} {$w insert end $i}
	 }
    }
}
