/*
  File :     print.h

  Author :   Stefania Alborghetti ($Author: printmi $)
  e-mail :   "stefania.alborghetti@mi.infn.it"

  Revision history :
   9-Oct-1997 Original release
   9-Sep-2010 (FP) Moved str_ctr to common.h (for cups_backend)


  Description: Common macros and prototypes for the print client.
*/
 
#ifndef PrintmiPRINTh
#define PrintmiPRINTh

#include "common.h"
#ifdef MULTINET
#include "multinet_root:[multinet.include]netdb.h"
#else
#include <netdb.h>
#endif

/* These are the host NAMES (or aliases), in the current domain, 
   of the primary and backup print servers. */

#define   SERV_HOST_NAME_I   "printmi1"
#define   SERV_HOST_NAME_II  "printmi2"

#define STDIN_BUFFER_SIZE 327680
#define MAX_COPY_NUMBER 10
#define I_AM_THE_CLIENT 1

/* Forward declarations */
int  _prints_check_data_file(char *file,int status);
int _prints_lpr_get_opt(int argc,char** argv,int *extra_files,int *extra_argc);
int _prints_lp_get_opt(int argc,char** argv,int *extra_files,int *extra_argc);
int _prints_lpq_get_opt(int argc,char** argv);
int _prints_lpc_get_opt(int argc, char** argv);
void _prints_lpr_usage(char* pname);
void _prints_lp_usage(char* pname);
int _prints_check_version(int sockfd);

int str_list(int sockfd, char *request);
int display_version(int sockfd);

#endif /* def PrintmiPRINTh */
